Starting a sketch, how about select plane in 3D space

Have some feature requests, feedback, cool stuff to share, or want to know where FreeCAD is going? This is the place.
Forum rules
Be nice to others! Read the FreeCAD code of conduct!
User avatar
NormandC
Veteran
Posts: 18589
Joined: Sat Feb 06, 2010 9:52 pm
Location: Québec, Canada

Re: Starting a sketch, how about select plane in 3D space

Post by NormandC »

While the doodling in DeepSOIC's screen capture is amusing, I have no clue what this scale-bar is supposed to represent or do. How is it to inform about the zoom level? Also, it would eat vertical space which in short supply since widescreen display are the norm...
freedman
Veteran
Posts: 3478
Joined: Thu Mar 22, 2018 3:02 am
Location: Washington State, USA

Re: Starting a sketch, how about select plane in 3D space

Post by freedman »

:lol:
OK, someones got to do it.
Galaxy
Solar system
Planet
I have no idea??????
Building
House
Bike
Cat
Mouse
Fly
I have no idea??????
I have no idea??????
Atom
User avatar
NormandC
Veteran
Posts: 18589
Joined: Sat Feb 06, 2010 9:52 pm
Location: Québec, Canada

Re: Starting a sketch, how about select plane in 3D space

Post by NormandC »

You're good freedman. I didn't know what the first icon was.

Next to last is a DNA strand maybe?

What's smaller than a fly, bigger than a DNA strand, and squarish? A microchip maybe?

OK now I think I understand the scaling bar. :lol:
User avatar
DeepSOIC
Veteran
Posts: 7896
Joined: Fri Aug 29, 2014 12:45 am
Location: used to be Saint-Petersburg, Russia

Re: Starting a sketch, how about select plane in 3D space

Post by DeepSOIC »

NormandC wrote: Sun Oct 14, 2018 11:31 pm A microchip maybe?
It was meant to be 0402 SMD resistor =) so you almost got it.
The thing no one guessed was supposed to be a city. I tried doodling a map of Moscow :mrgreen: , which has a very distinct shape. No wonder you didn't get it, but I don't have any better idea.
User avatar
NormandC
Veteran
Posts: 18589
Joined: Sat Feb 06, 2010 9:52 pm
Location: Québec, Canada

Re: Starting a sketch, how about select plane in 3D space

Post by NormandC »

Wow! I didn't know Moscow looked like a wheel hub. :)

https://www.openstreetmap.org/relation/2555133
User avatar
DeepSOIC
Veteran
Posts: 7896
Joined: Fri Aug 29, 2014 12:45 am
Location: used to be Saint-Petersburg, Russia

Re: Starting a sketch, how about select plane in 3D space

Post by DeepSOIC »

NormandC wrote: Sun Oct 14, 2018 11:18 pm Also, it would eat vertical space which in short supply since widescreen display are the norm...
It can be vertical. It can be integrated into status bar. It can have a prominent cross button, and only show up initially on a new project with nothing in it. And maybe on an imported file as a new document.
TheMarkster
Veteran
Posts: 5513
Joined: Thu Apr 05, 2018 1:53 am

Re: Starting a sketch, how about select plane in 3D space

Post by TheMarkster »

Here is a video showing what I have so far. I'm not sure if I have the Isometric, Dimetric, and Trimetric views exactly right yet. Could be the top view (0,0,1) isn't the correct starting vector. I added the preferences to the Display settings in Edit -> Preferences, including the ability to use the current orientation. You can also manually enter a custom orientation in the Tools -> Edit parameters menu in Base/Preferences/View by setting NewDocumentCameraOrientation to something like Rotation(0.5,0.5,0.5,0.5) or whatever numbers you choose. You can also use:

Rotation(Base.Vector(0,0,1),Base.Vector(.5,.5,.5,.5))

where the first vector is the from vector and the 2nd is the to vector if you want to use that method of setting up the orientation.

Limitation: it's not going to be translatable to other languages. If any translation is done it will break it because the text is part of the commands sent to python, example: activeView().TopView() where "Top" is the current setting.

phpBB [video]


I made a minor tweak after recording the video, consolidating some of the output to the python console so no new (potentially name-conflicting) python variables are being created.
User avatar
NormandC
Veteran
Posts: 18589
Joined: Sat Feb 06, 2010 9:52 pm
Location: Québec, Canada

Re: Starting a sketch, how about select plane in 3D space

Post by NormandC »

Thanks, things are progressing!
TheMarkster wrote: Mon Oct 15, 2018 1:20 am I'm not sure if I have the Isometric, Dimetric, and Trimetric views exactly right yet.
Yeah, sorry but that's not it. As I said, isometric should be exactly what axonometric is currently. And all three modes should always show the Z axis perfectly vertical.

I'll try to come up with values.
User avatar
DeepSOIC
Veteran
Posts: 7896
Joined: Fri Aug 29, 2014 12:45 am
Location: used to be Saint-Petersburg, Russia

Re: Starting a sketch, how about select plane in 3D space

Post by DeepSOIC »

Just in case you didn't know, there is a convenient Rotation constructor to make these rotations. For example, isometric:

Code: Select all

V = App.Vector
Gui.activeView().setCameraOrientation(App.Rotation(V(), V(0,0,1), V(1,1,1), "ZYX"))
TheMarkster
Veteran
Posts: 5513
Joined: Thu Apr 05, 2018 1:53 am

Re: Starting a sketch, how about select plane in 3D space

Post by TheMarkster »

DeepSOIC wrote: Mon Oct 15, 2018 10:52 am Just in case you didn't know, there is a convenient Rotation constructor to make these rotations. For example, isometric:

Code: Select all

V = App.Vector
Gui.activeView().setCameraOrientation(App.Rotation(V(), V(0,0,1), V(1,1,1), "ZYX"))
Nice tip. How to make dimetric and trimetric this way?

Edit: Okay, I think I have it. I can use Normand's vectors in place of V(1,1,1).
Post Reply